module topS(
input clk_ext,
input clk_in,

input key_1,
input key_2,
input key_3,
input key_4,

input sw_4,
input sw_5,
input sw_6,
input sw_7,

output led_3,
output led_4,
output led_5,
output led_6,

output j8_3,
output j8_4,
output j8_5,
output j8_6,
output j8_7,
output j8_8,
output j8_9,
output j8_10,
output j8_11,
output j8_12,
output j8_13,
output j8_14,
output j8_15,
output j8_16,
output j8_17,
output j8_18,
output j8_19,
output j8_20,
output j8_21,
output j8_22,
output j8_23,
output j8_24,
output j8_25,
output j8_26,
output j8_27,
output j8_28,
output j8_29,
output j8_30,
output j8_31,
output j8_32,
output j8_33,
output j8_34,
output j8_35,
output j8_36,
output j8_37,
output j8_38,

output j9_3,
output j9_4,
output j9_5,
output j9_6,
output j9_7,
output j9_8,
output j9_9,
output j9_10,
output j9_11,
output j9_12,
output j9_13,
output j9_14,
output j9_15,
output j9_16,
output j9_17,
output j9_18,
output j9_19,
output j9_20,
output j9_21,
output j9_22,
output j9_23,
output j9_24,
output j9_25,
output j9_26,
output j9_27,
output j9_28,
output j9_29,
output j9_30,
output j9_31,
output j9_32,
output j9_33,
output j9_34,
output j9_35,
output j9_36,
output j9_37,
output j9_38,

inout   j10_1,
output  j10_2,
inout   j10_5,
output  j10_6,
output  j10_9,
output  j10_10,
input j10_13,
input j10_14,
input j10_17,
input j10_18,

input j11_1,
input j11_2,
input j11_5,
input j11_6,
input j11_9,
input j11_10,
input j11_13,
input j11_14,
input j11_17,
input j11_18
);

//map table
localparam	rmap_basic_ctrl_1		=8'h00;
localparam	mask_enMaster			=0;
localparam	mask_lgcyMode			=1;
localparam	mask_enSEvent			=2;

localparam	rmap_basic_ctrl_2		=8'h01;
localparam	mask_participateDaa		=0;
localparam	mask_autoApplyDaa		=1;

localparam	rmap_call_ctrl			=8'h02;
localparam	mask_call				=0;
localparam	mask_ibi				=1;
localparam	mask_abortRead			=2;

localparam	rmap_hangup_ctrl		=8'h03;
localparam	mask_srWhenNack			=0;
localparam	mask_srWhenDone			=1;
localparam 	mask_srWhenAbort		=2;

localparam	rmap_prescale			=8'h04;
localparam	rmap_msg_length			=8'h05;
localparam	rmap_ddr_length			=8'h06;
localparam	rmap_slave_address		=8'h07;
localparam	rmap_msg_transcived		=8'h08;

localparam	rmap_cacheN_wptrL		=8'h10;
localparam	rmap_cacheN_wptrH		=8'h11;
localparam	rmap_cacheN_rptrL		=8'h12;
localparam	rmap_cacheN_rptrH		=8'h13;
localparam	rmap_cacheP_wptrL		=8'h14;
localparam	rmap_cacheP_wptrH		=8'h15;
localparam	rmap_cacheP_rptrL		=8'h16;
localparam	rmap_cacheP_rptrH		=8'h17;
localparam	rmap_cache_ptr_rst		=8'h18;
localparam	mask_cacheN_wprt_rst	=0;
localparam	mask_cacheN_rprt_rst	=1;
localparam	mask_cacheP_wprt_rst	=2;
localparam	mask_cacheP_rprt_rst	=3;

localparam	rmap_state				=8'h20;
localparam	rmap_next_state			=8'h21;

localparam	rmap_received_address	=8'h22;

localparam	rmap_irq_flag_1			=8'h30;
localparam	mask_done				=0;
localparam	mask_nack				=1;
localparam	mask_sta				=2;
localparam	mask_sr					=3;
localparam	mask_sto				=4;
localparam	mask_da					=5;
localparam	mask_lost				=6;

localparam	rmap_irq_flag_2			=8'h31;
localparam	mask_ddr_done			=0;
localparam	mask_ddr_sr				=1;
localparam	mask_ddr_exit			=2;

//clock system
wire lock;
wire clk10M;

//key system
wire    key1,key2,key3,key4;

//i3c phy
wire	        scl_i;
wire	        scl_o;
wire	        scl_oen;
wire	        sda_i;
wire	        sda_o;
wire	        sda_oen;
wire	        sdaPull_o;
wire	        sdaPull_oen;
wire	[7:0]	dataPO;
reg		[7:0]	dataPI	=0;
wire	[7:0]	dataNO;
reg		[7:0]	dataNI	=0;
reg		[11:0]	addr	=0;
reg				wre		=0;
wire            irq;
wire            rstn = key1;

wire    [11:0]  control_base_prt    = 12'h800;
wire    [11:0]  read_base_ptr       = 12'h000;
wire    [11:0]  write_base_ptr      = 12'h400;
reg     [7:0]   cnt                 = 0;

reg     [7:0]   dataNum             =0;
reg     [7:0]   dataNum_irq         =0;
reg     [7:0]   ddrByte0            =0;
reg     [7:0]   ddrByte1            =0;
reg             pcInc               = 1;

assign  led_3   = !irq;


reg     [7:0]   cnt                 =0;
reg     [7:0]   dataNum                 =0;

always @(posedge clk10M or negedge rstn)begin
    if(!rstn)begin
        cnt <=0;
    end
    else begin
        if(cnt ==0)begin
            if(key2)begin
                cnt <= cnt +1;
            end
            else begin
                cnt <= cnt;
            end
        end
        else begin
            if(cnt ==3)begin
                cnt <= cnt;
            end
            else begin
                if(cnt==2 && dataNum<5)begin
                    cnt <= cnt;
                end
                else begin
                    cnt<=cnt+1;
                end
            end
        end
    end
end

always @(posedge clk10M or negedge rstn)begin
    if(!rstn)begin
        wre<=0;
        addr<=12'h000;
        dataNI<=8'h00;
        dataNum<=0;
    end else if (cnt ==1)begin      //set master
        wre<=1;
        addr<=control_base_prt + rmap_slave_address;
        dataNI<= 8'h08;
        dataNum<=0;
    end else if (cnt == 2)begin     //slave data
        wre<=1;
        addr<=read_base_ptr+dataNum;
        dataNI<= 8'hf0+dataNum;
        dataNum<=dataNum+1;

    end else begin
        wre<=0;
        addr<=0;
        dataNI<= 0;
    end
end

//key system
deJitter deKey1(
	.keyPos_o	(),
	.keyNeg_o	(),
	.key_o		(key1),
    .key_i		(key_1),
    .clk_i		(!clk10M)
);
defparam deKey1.alwaysState =1;

deJitter deKey2(
	.keyPos_o	(),
	.keyNeg_o	(),
	.key_o		(key2),
    .key_i		(key_2),
    .clk_i		(!clk10M)
);
defparam deKey2.alwaysState =1;

//i3c phy
I3C_HDR iPhy(
	.scl_i		(scl_i),
	.scl_o		(scl_o),
	.scl_oen	(scl_oen),
	.sda_i		(sda_i),
	.sda_o		(sda_o),
	.sda_oen	(sda_oen),
	.sdaPull_o	(sdaPull_o),
	.sdaPull_oen(sdaPull_oen),
	.dataN_i	(dataNI),
	.dataN_o	(dataNO),
	.dataP_i	(dataPI),
	.dataP_o	(dataPO),
	.addr_i		(addr),
	.wre_i		(wre),
	.irq_o		(irq),
	.sysClk_i	(clk10M),
	.ce_i		(1'b1),
	.locRst_i	(1'b0),
	.rstn_i		(rstn)
);

bufif0	iBufSdaO(j10_1,sda_o,sda_oen);
buf		iBufSdaI(sda_i,j10_1);
bufif0	iBufSclO(j10_5,scl_o,scl_oen);
buf		iBufSclI(scl_i,j10_5);

bufif0	iBufsdapull(j10_2,sdaPull_o,sdaPull_oen);


//system clock
    GW_PLL myPll(
        .clkout(clk10M), //output clkout
        .lock(lock), //output lock
        .clkin(clk_in) //input clkin
    );
assign j8_3 = lock;
assign j8_4 = clk10M;

endmodule